unit Main;

interface

uses
  WinTypes, WinProcs, SysUtils, Messages, Classes, Graphics, Controls,
  Plusmemo, URLHighlight, Dialogs, Menus, StdCtrls, ExtCtrls, Buttons,
  PlusGutter, Forms, ExtHilit, OOPHilit, pmprint, HtmlHighlight, ExtDlgs;

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Save1: TMenuItem;
    PanToolbar: TPanel;
    SpeedBtnUnderline: TSpeedButton;
    SpeedBtnItalic: TSpeedButton;
    SpeedBtnBold: TSpeedButton;
    SpeedBtnPaste: TSpeedButton;
    SpeedBtnCopy: TSpeedButton;
    SpeedBtnCut: TSpeedButton;
    SpeedBtnPrint: TSpeedButton;
    SpeedBtnSearch: TSpeedButton;
    SpeedBtnSave: TSpeedButton;
    SpeedBtnOpen: TSpeedButton;
    Edit1: TMenuItem;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    SelectAll1: TMenuItem;
    Word1: TMenuItem;
    Search1: TMenuItem;
    Help1: TMenuItem;
    AboutNotepadPlus1: TMenuItem;
    Setup1: TMenuItem;
    Font1: TMenuItem;
    FontDialog1: TFontDialog;
    BackgroundColor1: TMenuItem;
    HighlightText1: TMenuItem;
    ColorDialog1: TColorDialog;
    HighlightBackgroundColor1: TMenuItem;
    SpeedBtnHighlight: TSpeedButton;
    PanStatus: TPanel;
    LblPar: TLabel;
    LblOffset: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    LblLine: TLabel;
    LblCol: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LblProgress: TLabel;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Statusbar1: TMenuItem;
    N5: TMenuItem;
    TextFormat1: TMenuItem;
    SpeedBtnAltFont: TSpeedButton;
    AlternateFont1: TMenuItem;
    N6: TMenuItem;
    Print1: TMenuItem;
    CaretWidth1: TMenuItem;
    N7: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Center1: TMenuItem;
    Justified1: TMenuItem;
    Undo1: TMenuItem;
    N8: TMenuItem;
    BtnUndo: TSpeedButton;
    PlusMemo1: TPlusMemo;
    Syntax1: TMenuItem;
    MnuKeywordsInternet: TMenuItem;
    MnuKeywordsDelphi: TMenuItem;
    MnuKeywordsCustom: TMenuItem;
    N9: TMenuItem;
    CustomKeywords1: TMenuItem;
    FindDialog1: TFindDialog;
    CustomStartstopkeys1: TMenuItem;
    Customdelimiters1: TMenuItem;
    Bevel4: TBevel;
    LblOverwrite: TLabel;
    Insert1: TMenuItem;
    Overwrite1: TMenuItem;
    N10: TMenuItem;
    LblUpdate: TLabel;
    BtnCodeEditor: TSpeedButton;
    BtnTextEditor: TSpeedButton;
    DisplayIntroonStartup1: TMenuItem;
    N11: TMenuItem;
    Redo1: TMenuItem;
    BtnRedo: TSpeedButton;
    N12: TMenuItem;
    AutoIndent1: TMenuItem;
    BackIndent1: TMenuItem;
    URLHighlighter1: TURLHighlighter;
    PlusGutter1: TPlusGutter;
    Gutter1: TMenuItem;
    PopupMenu1: TPopupMenu;
    MnuPopCopy: TMenuItem;
    N13: TMenuItem;
    MnuKeywordsNone: TMenuItem;
    LblSelMode: TLabel;
    LblFullLine: TLabel;
    OOPHighlighter1: TOOPHighlighter;
    PlusMemoPrinter1: TPlusMemoPrinter;
    BtnPrintPreview: TSpeedButton;
    MnuPrintPreview1: TMenuItem;
    HtmlHighlighter1: THtmlHighlighter;
    MnuKeywordsHtml: TMenuItem;
    LblBreak: TLabel;
    Toolbar1: TMenuItem;
    rgBackground: TRadioGroup;
    BtnCustomPic: TSpeedButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SpeedBtnBoldClick(Sender: TObject);
    procedure SpeedBtnItalicClick(Sender: TObject);
    procedure SpeedBtnUnderlineClick(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SelectAll1Click(Sender: TObject);
    procedure Word1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure BackgroundColor1Click(Sender: TObject);
    procedure HighlightText1Click(Sender: TObject);
    procedure HighlightBackgroundColor1Click(Sender: TObject);
    procedure SpeedBtnHighlightClick(Sender: TObject);
    procedure PlusMemo1Progress(Sender: TObject);
    procedure PlusMemo1StyleChange(Sender: TObject);
    procedure PlusMemo1SelMove(Sender: TObject);
    procedure AboutNotepadPlus1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Toolbar1Click(Sender: TObject);
    procedure Statusbar1Click(Sender: TObject);
    procedure TextFormat1Click(Sender: TObject);
    procedure SpeedBtnAltFontClick(Sender: TObject);
    procedure AlternateFont1Click(Sender: TObject);
    procedure CaretWidth1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Center1Click(Sender: TObject);
    procedure Justified1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure MnuKeywordsInternetClick(Sender: TObject);
    procedure MnuKeywordsDelphiClick(Sender: TObject);
    procedure MnuKeywordsCustomClick(Sender: TObject);
    procedure CustomKeywordsClick(Sender: TObject);
    procedure CustomStartstopkeys1Click(Sender: TObject);
    procedure LblOverwriteClick(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure Overwrite1Click(Sender: TObject);
    procedure LblUpdateClick(Sender: TObject);
    procedure BtnCodeEditorClick(Sender: TObject);
    procedure BtnTextEditorClick(Sender: TObject);
    procedure DisplayIntroonStartup1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure PlusMemo1Change(Sender: TObject);
    procedure PlusMemo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AutoIndent1Click(Sender: TObject);
    procedure BackIndent1Click(Sender: TObject);
    procedure Gutter1Click(Sender: TObject);
    procedure Customdelimiters1Click(Sender: TObject);
    procedure MnuKeywordsNoneClick(Sender: TObject);
    procedure LblSelModeClick(Sender: TObject);
    procedure LblFullLineClick(Sender: TObject);
    procedure BtnPrintPreviewClick(Sender: TObject);
    procedure SpeedBtnPrintClick(Sender: TObject);
    procedure MnuKeywordsHtmlClick(Sender: TObject);
    procedure LblBreakClick(Sender: TObject);
    procedure rgBackgroundClick(Sender: TObject);
    procedure BtnCustomPicClick(Sender: TObject);
 private
    { Private-dclarations }
    fEditFile: string;
    fSavedECMBmp: TBitmap;   { to keep a reference to the ECM background bitmap }
    fCustomBmp  : TBitmap;   { to contain a custom, user selected background bitmap }
    procedure setEditFile(const name: string);
 public
    OutputRTFFormat: Boolean;
    AppPath, TextEditorFont, TextEditorSeparators: string;
    CustomBmpFile  : string;

    property EditFile: string read fEditFile write setEditFile;

    procedure LoadFile(const fname: string);  { loads a file and set PlusMemo1 properties
                                                according to the type of file }

    procedure PlusMemo1LoadProgress(Sender: TObject);
                       { event handler used when loading a file }
    procedure PlusMemo1SaveProgress(Sender: TObject);
                       { event handler used when saving a file }
    { Public-dclarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}
uses About, Clipbrd, IniFiles, Printers, PlusKeys, ShellAPI;

const MainSection = 'Window';  { Various sections of notepadp.ini }
      ViewSection = 'View';
      FontSection = 'Font';
      ColorsSection='Colors';
      EditionSection='Edition';
      SetupSection  ='Setup';

procedure TFrmMain.FormCreate(Sender: TObject);
{$IFNDEF WIN32} const crHandPoint = crUpArrow; {$ENDIF}
               { this cursor is not defined in 16 bit Delphi }

var
  Inif : TIniFile;
  key  : string;
  DisplayIntroCode: Integer;
  CustomStream: TFileStream;
  CustomReader: TReader;

begin
  AppPath:= ExtractFilePath(Application.ExeName);

  { keep a reference to the background loaded with the project, in order to restore it at user will }
  fSavedECMBmp:= TBitmap.Create;
  fSavedECMBmp.Assign(PlusMemo1.BackgroundBmp.Bitmap);

  { create a bitmap to hold the user selected one (custom) }
  fCustomBmp:= TBitmap.Create;

  Inif:= TIniFile.Create(AppPath + 'notepadp.ini');
  with Inif do
    begin
      { load general settings }
      Width:= ReadInteger(MainSection, 'Width', Width);
      Height:= ReadInteger(MainSection, 'Height', Height);
      Top:= ReadInteger(MainSection, 'Top', (Screen.Height-Height) div 2);
      Left:= ReadInteger(MainSection, 'Left', (Screen.Width - Width) div 2);
      WindowState:= TWindowState(ReadInteger(MainSection, 'State', ord(wsNormal)));

      PanToolbar.Visible:= ReadBool(ViewSection, 'ToolBar', True);
      PanStatus.Visible:=  ReadBool(ViewSection, 'Status', True);
      PlusGutter1.Visible:= ReadBool(ViewSection, 'Gutter', True);
      CustomBmpFile:= ReadString(ViewSection, 'CustomBmp', '');
      rgBackground.ItemIndex:= ReadInteger(ViewSection, 'BackgroundPic', 1);

      DisplayIntroCode:= ReadInteger(ViewSection, 'Intro', -1);
      if ParamCount=0 then
        begin
          EditFile:='';
          if DisplayIntroCode=0 then PlusMemo1.Lines.Clear
          else
            if DisplayIntroCode<>0 then DisplayIntroOnStartup1.Checked:= True;
          PlusMemo1.Modified:= False
        end;

      Toolbar1.Checked:= PanToolbar.Visible;
      Statusbar1.Checked:= PanStatus.Visible;
      PlusMemo1.Separators:= ReadString(MainSection, 'Custom delimiters', '.,;:[]{}()/')+' '#9;
      TextEditorSeparators:= PlusMemo1.Separators;


      { here is how to read keywords and start-stop keys from a stream!! }
      CustomStream:= nil;
      try
        CustomStream:= TFileStream.Create(AppPath+'CustKeys.bin', fmOpenRead);
        CustomReader:= TReader.Create(CustomStream, 1024);
        PlusMemo1.Keywords.ReadData(CustomReader);
        PlusMemo1.StartStopKeys.ReadData(CustomReader);
        CustomReader.Free;
      except
        end;
      CustomStream.Free;

      { read from ini file which syntax highlighting to apply }
      MnuKeywordsInternet.Checked:= ReadBool(MainSection, 'Urls', True);
      key:= ReadString(MainSection, 'Syntax', 'Custom');

      if (key='None') or (DisplayIntroCode=-1) then MnuKeywordsNoneClick(Self)
      else
         begin
           if key='Delphi' then MnuKeywordsDelphiClick(Self);
           if key='Custom' then MnuKeywordsCustomClick(Self)
         end;

      { load PlusMemo settings }
      TextEditorFont:= ReadString(FontSection, 'Type', 'Arial');
      if DisplayIntroCode<>-1 then  { -1 is a flag for not having found notepadp.ini }
        with PlusMemo1 do
          begin
            Font.Name:= TextEditorFont;
            Font.Style:= [];

            Font.Size:= ReadInteger(FontSection, 'Size', Font.Size);
            Font.Color:= ReadInteger(FontSection, 'Color', Font.Color);
            AltFont.Name:= ReadString(FontSection, 'AlternateType', AltFont.Name);
            AltFont.Size:= ReadInteger(FontSection, 'AlternateSize', AltFont.Size);
            SpeedBtnAltFont.Font.Name:= PlusMemo1.AltFont.Name;

            Color:=  ReadInteger(ColorsSection, 'Background', clWindow);
            HighlightColor:= ReadInteger(ColorsSection, 'Highlight text', HighlightColor);
            HighlightBackgnd:= ReadInteger(ColorsSection, 'Highlight backgrnd', HighlightBackgnd);

            EnableHotKeys:= ReadBool(EditionSection, 'Text formatting', EnableHotKeys);
            TextFormat1.Checked:= EnableHotKeys;

            WordWrap:= ReadBool(SetupSection, 'Word wrap', WordWrap);
            Word1.Checked:= WordWrap;

            CaretWidth:= ReadInteger(SetupSection, 'Caret width', CaretWidth);

            case TAlignment(ReadInteger(SetupSection, 'Alignment', ord(taLeftJustify))) of
                taLeftJustify  : Left1Click(Self);
                taRightJustify : Right1Click(Self);
                taCenter       : Center1Click(Self)
              end;

            Justified:= ReadBool(SetupSection, 'Justified', Justified);
            Justified1.Checked:= Justified;

          end;  { with PlusMemo1 }

      Free
    end;   { with Inif }

  if ParamCount>0 then LoadFile(ParamStr(1))
                  else PlusMemo1SelMove(Self)   { update status bar }

end;    { FormCreate }

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Inif        : TIniFile;
  fsint       : Byte;
  InifName    : string;
  key         : string;
  CustomStream: TFileStream;
  CustomWriter: TWriter;
begin
  FindDialog1.CloseDialog;

  InifName:= AppPath+'notepadp.ini';
  Inif:= TIniFile.Create(InifName);
  with Inif do
    begin
      { save general settings }
      WriteInteger(MainSection, 'Width', Width);
      WriteInteger(MainSection, 'Height', Height);
      WriteInteger(MainSection, 'Top', Top);
      WriteInteger(MainSection, 'Left', Left);
      WriteInteger(MainSection, 'State', ord(WindowState));

      WriteBool(ViewSection, 'ToolBar', PanToolbar.Visible);
      WriteBool(ViewSection, 'Status', PanStatus.Visible);
      WriteInteger(ViewSection, 'Intro', Ord(DisplayIntroOnStartup1.Checked));
      WriteBool(ViewSection, 'Gutter', PlusGutter1.Visible);
      WriteString(ViewSection, 'CustomBmp', CustomBmpFile);
      WriteInteger(ViewSection, 'BackgroundPic', rgBackground.ItemIndex);

      key:= 'None';
      if MnuKeywordsDelphi.Checked then key:= 'Delphi';
      if MnuKeywordsCustom.Checked then key:= 'Custom';
      WriteString(MainSection, 'Syntax', key);
      WriteBool(MainSection, 'Urls', MnuKeywordsInternet.Checked);
      WriteString(MainSection, 'Custom delimiters', TextEditorSeparators);

      { here is how to save keywords and start-stopkeys in a stream!! }
      CustomStream:= TFileStream.Create(AppPath+'CustKeys.bin', fmCreate);
      CustomWriter:= TWriter.Create(CustomStream, 1024);
      PlusMemo1.Keywords.WriteData(CustomWriter);
      PlusMemo1.StartStopKeys.WriteData(CustomWriter);
      CustomWriter.Free;
      CustomStream.Free;

      { save PlusMemo settings }
      with PlusMemo1 do
        begin
          WriteString(FontSection, 'Type', TextEditorFont);
          WriteInteger(FontSection, 'Size', Font.Size);
          fsint:= 0;
          TFontStyles(fsint):= Font.Style;
          WriteInteger(FontSection, 'Style', fsint);
          WriteInteger(FontSection, 'Color', Font.Color);
          WriteString(FontSection, 'AlternateType', AltFont.Name);
          WriteInteger(FontSection, 'AlternateSize', AltFont.Size);

          WriteInteger(ColorsSection, 'Background', Color);
          WriteInteger(ColorsSection, 'Highlight text', HighlightColor);
          WriteInteger(ColorsSection, 'Highlight backgrnd', HighlightBackgnd);
          WriteBool(EditionSection, 'Text formatting', EnableHotKeys);
          WriteBool(SetupSection, 'Word wrap', WordWrap);
          WriteInteger(SetupSection, 'Caret width', CaretWidth);
          WriteInteger(SetupSection, 'Alignment', ord(Alignment));
          WriteBool(SetupSection, 'Justified', Justified)
        end;  { with PlusMemo1 }

      Free
    end;   { with Inif }

  fSavedECMBmp.Free;
  fCustomBmp.Free
end;  { FormClose }

procedure TFrmMain.setEditFile(const Name: string);
  { write access method for EditFile public property:
         set the Notepad Plus caption, and settings
         according to the type of file just loaded }
var ext: string;
begin
  fEditFile:= Name;
  if name<>'' then Caption:= 'Notepad Plus - ' + ExtractFileName(name)
              else Caption:= 'Notepad Plus - Untitled';
  Application.Title:= Caption;
  ext:= UpperCase(ExtractFileExt(Name));

  if (ext='.PAS') and (not BtnCodeEditor.Down) then
    begin
      BtnCodeEditor.Down:= True;
      BtnCodeEditorClick(Self)  { set code editor settings }
    end;

  if (ext='.TXT') and (not BtnTextEditor.Down) then
    begin
      BtnTextEditor.Down:= True;
      BtnTextEditorClick(Self)  { set text editor settings }
    end;

  if (ext='.HTM') or (ext='.HTML') then MnuKeywordsHtmlClick(Self)
end;


var FileStream: TFileStream;
  { The stream used when loading and saving is available globally
    because we want to know how much has been processed in load and
    save progress event handler }

procedure TFrmMain.LoadFile(const FName: string);
begin
  FileStream:= TFileStream.Create(FName, fmOpenRead);

  try
    with PlusMemo1 do
    begin
      OnProgress:= PlusMemo1LoadProgress;  { temporarily change the OnProgress handler
                                             to point to the load status update }
      LoadFromStream(FileStream);
      OnProgress:= PlusMemo1Progress;      { return it to its default (format status update }
      Modified:= False;
      LblProgress.Hide
    end;
  finally
    FileStream.Destroy
    end;

  PlusMemo1SelMove(Self);
  PlusMemo1StyleChange(Self);
  EditFile:= FName
end;

procedure TFrmMain.PlusMemo1LoadProgress;
  { PlusMemo1.OnProgress event handler, when loading a file }
begin
  with FileStream do
    if Size>0 then
      begin
        LblProgress.Visible:= True;
        LblProgress.Caption:= 'loading ' + IntToStr((Position *100) div Size) + '%';
        if Position>=Size-1 then PlusMemo1.OnProgress:= PlusMemo1Progress;
        LblProgress.Update
      end;
  end;

procedure TFrmMain.PlusMemo1SaveProgress;
{ PlusMemo1.OnProgress event handler, when saving a file }
begin
  if PlusMemo1.CharCount=0 then Exit;
  LblProgress.Visible:= True;
  with FileStream do
    LblProgress.Caption:= 'saving ' + IntToStr((Size*100) div PlusMemo1.CharCount) + '%';
  LblProgress.Update
end;

procedure TFrmMain.Cut1Click(Sender: TObject);
  { event handler for Edit/Cut menu item .OnClick }
  {          also for Cut speed button .OnClick }
begin
  PlusMemo1.CutToClipboard
end;

procedure TFrmMain.Paste1Click(Sender: TObject);
  { event handler for Edit/Paste menu item .OnClick
             also for Paste speed button   .OnClick }
begin
  PlusMemo1.PasteFromClipboard
end;

procedure TFrmMain.Copy1Click(Sender: TObject);
   { event handler for Edit/Copy menu item .OnClick
              also for Copy speed button   .OnClick }
begin
  PlusMemo1.CopyToClipboard
end;

procedure TFrmMain.Save1Click(Sender: TObject);
   { event handler for File/Save menu item .OnClick }
   {          also for Save speed button   .OnClick }
begin
  if EditFile='' then SaveAs1Click(Save1)
  else
    if EditFile<>'' then
      with PlusMemo1 do
        begin
          OnProgress:= PlusMemo1SaveProgress;
          FileStream:= TFileStream.Create(EditFile, fmCreate);
          try
            if OutputRTFFormat then SaveToRTFStream(FileStream, True)
                               else SaveToStream(FileStream);
            Modified:= False;
          finally
            FileStream.Destroy
            end;
          LblProgress.Hide;
          OnProgress:= PlusMemo1Progress
        end
end;

procedure TFrmMain.SaveAs1Click(Sender: TObject);
   { event handler for File/Save As menu item .OnClick }
   { also called by Save function if no file name is present }
var ext: string;   { the file extension }
begin
  if SaveDialog1.Execute then
    begin
      EditFile:= SaveDialog1.FileName;
      ext:= UpperCase(ExtractFileExt(EditFile));
      if (ext='') and (EditFile[Length(EditFile)]<>'.') then
                                        EditFile:= EditFile+'.TXT';
      OutputRTFFormat:= ext='.RTF'; {SaveDialog1.FilterIndex=2;}
      Save1Click(SaveAs1)
    end
end;

procedure TFrmMain.New1Click(Sender: TObject);
   { event handler for File/New menu item  .OnClick }
var canDiscard: Boolean;
begin
  FormCloseQuery(New1, canDiscard); { can we discard the current file ? }
  if canDiscard then
    begin
      PlusMemo1.Clear;
      EditFile:= '';
      PlusMemo1.Modified:= False;
    end
end;

procedure TFrmMain.Open1Click(Sender: TObject);
   { event handler for File/Open menu item  .OnClick }
             {also for Open speed button    .OnClick }
var canDiscard: Boolean;
begin
  FormCloseQuery(Open1, canDiscard); { can we discard the current file? }
  if canDiscard then
    if OpenDialog1.Execute then LoadFile(OpenDialog1.FileName);
end;

procedure TFrmMain.SpeedBtnBoldClick(Sender: TObject);
   { event handler for Bold speed button }
begin
  PlusMemo1.SetBold;
  SpeedBtnBold.Down:= fsBold in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnItalicClick(Sender: TObject);
   { event handler for Italic speed button }
begin
  PlusMemo1.SetItalic;
  SpeedBtnItalic.Down:= fsItalic in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnUnderlineClick(Sender: TObject);
   { event handler for Underline speed button }
begin
  PlusMemo1.SetUnderline;
  SpeedBtnUnderline.Down:= fsUnderline in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnHighlightClick(Sender: TObject);
   { event handler for Highlight speed button }
begin
  PlusMemo1.SetHighlight;
  SpeedBtnHighlight.Down:= fsHighlight in PlusMemo1.SelStyle
end;

procedure TFrmMain.SpeedBtnAltFontClick(Sender: TObject);
   { event handler for Alternate font speed button }
begin
  PlusMemo1.SetAltFont;
  SpeedBtnAltFont.Down:= fsAltFont in PlusMemo1.SelStyle
end;

procedure TFrmMain.Exit1Click(Sender: TObject);
   { event handler for File/Exit menu item }
begin
  Close
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
   { event handler for Main.OnCloseQuery }
begin
  CanClose:= True;
  if PlusMemo1.Modified then
    case MessageDlg('Save changes to "' + ExtractFileName(EditFile) + '"?',
                         mtConfirmation, mbYesNoCancel, 0) of
        mrYes   : Save1Click(Self);
        mrCancel: CanClose:= False
        end
end;

procedure TFrmMain.SelectAll1Click(Sender: TObject);
   { event handler for Edit/Select All menu item }
begin
  PlusMemo1.SelectAll
end;

procedure TFrmMain.Word1Click(Sender: TObject);
   { event handler for Setup/Word Wrap menu item }
begin
  with PlusMemo1 do
    begin
      Word1.Checked:= not Word1.Checked;

      { ensure that KeepColumnPos is not there if word wrap is off, otherwise navigation behavior will look strange }
      if not Word1.Checked then Options:= Options - [pmoKeepColumnPos];
      Wordwrap:= Word1.Checked;
    end
end;

procedure TFrmMain.Font1Click(Sender: TObject);
   { event handler for Setup/Font menu item }
begin
  FontDialog1.Font:= PlusMemo1.Font;
  if FontDialog1.Execute then
    begin
      PlusMemo1.Font:= FontDialog1.Font;
      if BtnTextEditor.Down then TextEditorFont:= PlusMemo1.Font.Name
    end
end;

procedure TFrmMain.AlternateFont1Click(Sender: TObject);
   { event handler for Setup/Alternate Font menu item }
begin
  FontDialog1.Font:= PlusMemo1.AltFont;
  if FontDialog1.Execute then
    begin
      PlusMemo1.AltFont:= FontDialog1.Font;
      SpeedBtnAltFont.Font.Name:= FontDialog1.Font.Name
    end
end;


procedure TFrmMain.BackgroundColor1Click(Sender: TObject);
   { event handler for Setup/Background Color menu item }
begin
  ColorDialog1.Color:= PlusMemo1.Color;
  if ColorDialog1.Execute then PlusMemo1.Color:= ColorDialog1.Color
end;

procedure TFrmMain.HighlightText1Click(Sender: TObject);
   { event handler for Setup/Highlight Text Color menu item }
begin
  ColorDialog1.Color:= PlusMemo1.HighlightColor;
  if ColorDialog1.Execute then PlusMemo1.HighlightColor:= ColorDialog1.Color
end;

procedure TFrmMain.HighlightBackgroundColor1Click(Sender: TObject);
   { event handler for Setup/Highlight Background Color menu item }
begin
  ColorDialog1.Color:= PlusMemo1.HighlightBackgnd;
  if ColorDialog1.Execute then PlusMemo1.HighlightBackgnd:= ColorDialog1.Color
end;

procedure TFrmMain.PlusMemo1Progress(Sender: TObject);
   { PlusMemo1.OnProgress event handler (except when loading or saving) }
var done: Integer;
begin
  done:= PlusMemo1.FormatCompleted;
  if done<100 then
    begin
      LblProgress.Visible:= True;
      LblProgress.Caption:= 'formatting ' + IntToStr(done) +'%';
      LblProgress.Update
    end
  else
    LblProgress.Hide;
end;

procedure TFrmMain.PlusMemo1StyleChange(Sender: TObject);
   { PlusMemo1.OnStyleChange event handler }
var fs: TExtFontStyles;
begin
  fs:= PlusMemo1.SelStyle;
  SpeedBtnBold.Down:= fsBold in fs;
  SpeedBtnItalic.Down:= fsItalic in fs;
  SpeedBtnUnderline.Down:= fsUnderline in fs;
  SpeedBtnHighlight.Down:= fsHighlight in fs;
  SpeedBtnAltFont.Down:= fsAltFont in fs
end;

procedure TFrmMain.PlusMemo1SelMove(Sender: TObject);
   { PlusMemo1.OnSelMove event handler }
begin
  LblProgress.Hide;
  with PlusMemo1 do
    begin
      LblOffset.Caption:= IntToStr(SelStart);
      LblPar.Caption   := IntToStr(SelPar+1);
      LblLine.Caption  := IntToStr(SelLine+1);
      LblCol.Caption   := IntToStr(SelCol+1)
    end
end;

procedure TFrmMain.AboutNotepadPlus1Click(Sender: TObject);
   { event handler for Help/About menu item }
begin
  AboutBox.Show
end;

procedure TFrmMain.Find1Click(Sender: TObject);
   { event handler for Search/Find... menu item }
begin
  if PlusMemo1.SelLength=0 then FindDialog1.FindText:= PlusMemo1.CurrentWord
  else
    if Abs(PlusMemo1.SelLength)<64 then FindDialog1.FindText:= PlusMemo1.SelText;
  FindDialog1.Execute
end;


procedure TFrmMain.Toolbar1Click(Sender: TObject);
   { event handler for Setup/Toolbar menu item }
begin
  with PanToolbar do
    begin
      Visible:= not Visible;
      Toolbar1.Checked:= Visible
    end
end;

procedure TFrmMain.Statusbar1Click(Sender: TObject);
   { event handler for Setup/Status bar menu item }
begin
  with PanStatus do
    begin
      Visible:= not Visible;
      Statusbar1.Checked:= Visible
    end
end;

procedure TFrmMain.TextFormat1Click(Sender: TObject);
   { event handler for Setup/Text formatting edition menu item }
begin
  with PlusMemo1 do
    begin
      EnableHotKeys:= not EnableHotKeys;
      TextFormat1.Checked:= EnableHotKeys
    end
end;


procedure TFrmMain.CaretWidth1Click(Sender: TObject);
  { event handler for Setup/CaretWidth... menu item }

var cwstr: string;
begin
  cwstr:= IntToStr(PlusMemo1.CaretWidth);
  if InputQuery('Setting caret width', 'Enter the new value (0 means auto width)', cwstr) then
      PlusMemo1.CaretWidth:= StrToInt(cwstr)
end;

procedure TFrmMain.Right1Click(Sender: TObject);
   { event handler for Setup/Right menu item }
begin
  PlusMemo1.Alignment:= taRightJustify;
  Right1.Checked:= True;
  Left1.Checked:= False;
  Center1.Checked:= False;
end;

procedure TFrmMain.Left1Click(Sender: TObject);
   { event handler for Setup/Left menu item }
begin
  PlusMemo1.Alignment:= taLeftJustify;
  Right1.Checked:= False;
  Left1.Checked:= True;
  Center1.Checked:= False;
end;

procedure TFrmMain.Center1Click(Sender: TObject);
   { event handler for Setup/Center menu item }
begin
  PlusMemo1.Alignment:= taCenter;
  Right1.Checked:= False;
  Left1.Checked:= False;
  Center1.Checked:= True;
end;

procedure TFrmMain.Justified1Click(Sender: TObject);
   { event handler for Setup/Justified menu item }
begin
  Justified1.Checked:= not Justified1.Checked;
  PlusMemo1.Justified:= Justified1.Checked
end;

procedure TFrmMain.FindDialog1Find(Sender: TObject);
  { FindDialog1.OnFind event handler }
begin
  Screen.Cursor:= crHourGlass;
  with FindDialog1 do
    if PlusMemo1.FindText(FindText, frDown in Options, frMatchCase in Options, frWholeWord in Options) then
        PlusMemo1.ScrollInView
    else ShowMessage('Search string not found');

  Screen.Cursor:= crDefault;
  SetFocus;
  FindNext1.Enabled:= True;
  FindDialog1.CloseDialog
end;

procedure TFrmMain.FindNext1Click(Sender: TObject);
   { event handler for Search/Find Next menu item }
begin
  FindDialog1Find(FindNext1)
end;

procedure TFrmMain.Undo1Click(Sender: TObject);
   { event handler for Edit/Undo menu item }
begin
  PlusMemo1.Undo
end;

procedure TFrmMain.Edit1Click(Sender: TObject);
   { event handler for Edit menu item }
begin
  { set the enable property of Undo and Redo menu items
    according to the current state of PlusMemo1 }
  Undo1.Enabled:= PlusMemo1.CanUndo;
  Redo1.Enabled:= PlusMemo1.CanRedo
end;

procedure TFrmMain.MnuKeywordsInternetClick(Sender: TObject);
   { event handler for Syntax/Internet menu item }
begin
  MnuKeywordsInternet.Checked:= not MnuKeywordsInternet.Checked;

  if MnuKeywordsInternet.Checked then
    begin
      OOPHighlighter1.SubHighlighter:= UrlHighlighter1;
      if  PlusMemo1.Highlighter <> OOPHighlighter1 then PlusMemo1.Highlighter:= UrlHighlighter1
    end
  else
    begin
      OOPHighlighter1.SubHighlighter:= nil;
      if PlusMemo1.Highlighter <> OOPHighlighter1 then PlusMemo1.Highlighter:= nil
    end;

  PlusMemo1.ReApplyKeywords;
end;

procedure TFrmMain.MnuKeywordsDelphiClick(Sender: TObject);
   { event handler for Syntax/Delphi menu item }
begin
  MnuKeywordsDelphi.Checked:= True;
  MnuKeywordsCustom.Checked:= False;
  MnuKeywordsNone.Checked:= False;
  MnuKeywordsHtml.Checked:= False;
  with PlusMemo1 do
    begin    { use the TOOPHighlighter }
      ApplyKeywords:= False;
      ApplyStartStopKeys:= False;
      Highlighter:= OOPHighlighter1;
      ReApplyKeywords
    end;
end;

procedure TFrmMain.MnuKeywordsHtmlClick(Sender: TObject);
    { event handler for Syntax/Html menu item }
begin
  MnuKeywordsDelphi.Checked:= False;
  MnuKeywordsCustom.Checked:= False;
  MnuKeywordsHtml.Checked:= True;
  MnuKeywordsNone.Checked:= False;
  with PlusMemo1 do
    begin
      Highlighter:= HtmlHighlighter1;
      UrlHighlighter1.Scope:= HtmlCommentScope;  { highlight urls inside html comments }
      ApplyKeywords:= False;
      ApplyStartStopKeys:= False;
      ReApplyKeywords
    end;
end;


procedure TFrmMain.MnuKeywordsCustomClick(Sender: TObject);
   { event handler for Syntax/Custom menu item }
begin
  MnuKeywordsCustom.Checked:= True;
  MnuKeywordsDelphi.Checked:= False;
  MnuKeywordsHtml.Checked:= False;
  MnuKeywordsNone.Checked:= False;
  with PlusMemo1 do
    begin
      ApplyKeywords:= True;
      ApplyStartStopKeys:= True;
      if MnuKeywordsInternet.Checked then Highlighter:= UrlHighlighter1
                                     else Highlighter:= nil;
      UrlHighlighter1.Scope:= 0;
      ReApplyKeywords
    end;
end;

procedure TFrmMain.MnuKeywordsNoneClick(Sender: TObject);
    { event handler for Syntax/None menu item }
begin
  MnuKeywordsDelphi.Checked:= False;
  MnuKeywordsCustom.Checked:= False;
  MnuKeywordsHtml.Checked:= False;
  MnuKeywordsNone.Checked:= True;
  with PlusMemo1 do
    begin
      ApplyKeywords:= False;
      ApplyStartStopKeys:= False;
      if MnuKeywordsInternet.Checked then Highlighter:= UrlHighlighter1
                                     else Highlighter:= nil;
      UrlHighlighter1.Scope:= 0;
      ReApplyKeywords
    end;
end;

procedure TFrmMain.CustomKeywordsClick(Sender: TObject);
   { event handler for Keywords/Custom Keywords... menu item }
begin
  if EditKeywordList(PlusMemo1.Keywords) and MnuKeywordsCustom.Checked then
    PlusMemo1.ReApplyKeywords
end;

procedure TFrmMain.CustomStartstopkeys1Click(Sender: TObject);
   { event handler for Keywords/CustomStartStopKeys... menu item }
begin
  if EditStartStopList(PlusMemo1.StartStopKeys) and MnuKeywordsCustom.Checked then
    PlusMemo1.ReApplyKeywords
end;


procedure TFrmMain.LblOverwriteClick(Sender: TObject);
   { event handler for INSERT status .OnClick
              also called by Edit/Insert and Edit/Overwrite menu item handlers }
begin
  PlusMemo1.OverWrite:= not PlusMemo1.OverWrite;
  if PlusMemo1.OverWrite then
    begin
      LblOverwrite.Caption:= 'OVERWRITE';
      Overwrite1.Checked:= True;
      Insert1.Checked:= False
    end
  else
      begin
        LblOverwrite.Caption:= 'INSERT';
        Overwrite1.Checked:= False;
        Insert1.Checked:= True
      end
end;

procedure TFrmMain.Insert1Click(Sender: TObject);
   { event handler for Edit/Insert menu item }
begin
  if not Insert1.Checked then LblOverwriteClick(Insert1)
end;

procedure TFrmMain.Overwrite1Click(Sender: TObject);
   { event handler for Edit/Overwrite menu item }
begin
  if not Overwrite1.Checked then LblOverwriteClick(Overwrite1)
end;

procedure TFrmMain.LblUpdateClick(Sender: TObject);
   { event handler for update status label;
        this is the label at the rightmost position
        on the status bar; it indicates the current value
        of PlusMemo1.UpdateMode.
        Clicking on this label will make UpdateMode cycle through
        its possible values.  This way, one can appreciate what is
        the effect of the various settings }
begin
  with PlusMemo1 do
    begin
      if UpdateMode<High(TUpdateMode) then UpdateMode:= Succ(UpdateMode)
                                      else UpdateMode:= Low(TUpdateMode);
      with LblUpdate do
        case UpdateMode of
          umImmediate : Caption:= 'immediate';
          umBackground: Caption:= 'background';
          umOnNeed    : Caption:= 'on need'
          end
    end;
end;


procedure TFrmMain.BtnCodeEditorClick(Sender: TObject);
   { event handler for Code Editor setup speed button
      also called by setEditFile method when loading a .PAS file }
begin
  BtnCodeEditor.AllowAllUp:= False;
  with PlusMemo1 do
    begin
      Lines.BeginUpdate;  { avoid unnecessary formatting and refresh while changing
                            various properties }
      Options:= [pmoKeepColumnPos, pmoPutExtraSpaces, pmoWrapCaret,
                 pmoInsertKeyActive, pmoWideOverwriteCaret, pmoAutoScrollBars,
                 pmoAutoIndent, pmoBackIndent, pmoDiscardTrailingSpaces];
      WordWrap:= False;
      Font.Name:= 'Courier New';
      MnuKeywordsDelphiClick(Self);
      Delimiters:= OOPDelimiters; 
      Lines.EndUpdate;
    end;

  { Update menu items }
  Word1.Checked:= False;   { Word Wrap menu item }
  AutoIndent1.Checked:= True;
  BackIndent1.Checked:= True;

  { Update buttons }
  SpeedBtnBold.Hide;
  SpeedBtnItalic.Hide;
  SpeedBtnUnderline.Hide;
  SpeedBtnHighlight.Hide;
  SpeedBtnAltFont.Hide
end;

procedure TFrmMain.BtnTextEditorClick(Sender: TObject);
   { event handler for Text Editor setup speed button
      also called by setEditFile method when loading a .TXT file }
begin
  BtnTextEditor.AllowAllUp:= False;
  with PlusMemo1 do
    begin
      Lines.BeginUpdate;  { avoid unnecessary formatting and refresh while changing
                            various properties }
      Options:= [pmoInsertKeyActive, pmoWideOverwriteCaret, pmoLargeWordSelect,
                 pmoAutoScrollBars];
      WordWrap:= True;
      Font.Name:= TextEditorFont;
      Separators:= TextEditorSeparators;
      if MnuKeywordsDelphi.Checked then MnuKeywordsCustomClick(Self);
      Lines.EndUpdate
    end;

  { Update menu items }
  Word1.Checked:= True;
  AutoIndent1.Checked:= False;
  BackIndent1.Checked:= False;

  { Update buttons }
  SpeedBtnBold.Show;
  SpeedBtnItalic.Show;
  SpeedBtnUnderline.Show;
  SpeedBtnHighlight.Show;
  SpeedBtnAltFont.Show
end;

procedure TFrmMain.DisplayIntroonStartup1Click(Sender: TObject);
   { event handler for File/Display Intro on Start up menu item }
begin
  with DisplayIntroOnStartup1 do Checked:= not Checked
end;

procedure TFrmMain.Redo1Click(Sender: TObject);
   { event handler for Edit/Redo menu item
              also for Redo speed button  }
begin
  PlusMemo1.Redo
end;

procedure TFrmMain.PlusMemo1Change(Sender: TObject);
   { PlusMemo1.OnChange event handler:
     Update the Undo and Redo speed button state }
begin
  BtnUndo.Enabled:= PlusMemo1.CanUndo;
  BtnRedo.Enabled:= PlusMemo1.CanRedo
end;

procedure TFrmMain.PlusMemo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
   { PlusMemo1.OnKeyDown event handler:
         Update the INSERT status label if Insert key is pressed }
begin
  if Key=VK_Insert then
    begin
      LblOverwriteClick(PlusMemo1);
      Key:= 0
    end
end;

procedure TFrmMain.AutoIndent1Click(Sender: TObject);
   { event handler for Setup/Auto Indent menu item }
begin
  with AutoIndent1 do
    begin
      Checked:= not Checked;
      if Checked then PlusMemo1.Options:= PlusMemo1.Options + [pmoAutoIndent]
                 else PlusMemo1.Options:= PlusMemo1.Options - [pmoAutoIndent]
    end
end;

procedure TFrmMain.BackIndent1Click(Sender: TObject);
   { event handler for Setup/Back indent menu item }
begin
  with BackIndent1 do
    begin
      Checked:= not Checked;
      if Checked then PlusMemo1.Options:= PlusMemo1.Options + [pmoBackIndent]
                 else PlusMemo1.Options:= PlusMemo1.Options - [pmoBackIndent]
    end
end;

procedure TFrmMain.Gutter1Click(Sender: TObject);
  { event handler for Setup/Gutter menu item }
begin
  Gutter1.Checked:= not Gutter1.Checked;
  PlusGutter1.Visible:= Gutter1.Checked
end;

procedure TFrmMain.Customdelimiters1Click(Sender: TObject);
  { event handler for Keywords/Custom delimiters menu item }
begin
  if InputQuery('', 'Enter the delimiters to use when in text mode', TextEditorSeparators) then
    begin
      if not BtnCodeEditor.Down then PlusMemo1.Separators:= TextEditorSeparators + ' '#9;
      if MnuKeywordsCustom.Checked then PlusMemo1.ReApplyKeywords
    end
end;


procedure TFrmMain.LblSelModeClick(Sender: TObject);
    { Event handler for Sel mode label OnClick }
begin
  with PlusMemo1 do
    if pmoWindowsSelColors in Options then
      begin
        Options:= Options - [pmoWindowsSelColors];
        LblSelMode.Caption:= 'Invert'
      end
    else
      begin
        Options:= Options + [pmoWindowsSelColors];
        LblSelMode.Caption:= 'Windows'
      end
end;

procedure TFrmMain.LblFullLineClick(Sender: TObject);
    { Event handler for full/short line selection OnClick }
begin
  with PlusMemo1 do
    if pmoFullLineSelect in Options then
      begin
        Options:= Options - [pmoFullLineSelect];
        LblFullLine.Caption:= 'short select'
      end
    else
      begin
        Options:= Options + [pmoFullLineSelect];
        LblFullLine.Caption:= 'long select'
      end
end;

procedure TFrmMain.BtnPrintPreviewClick(Sender: TObject);
    { Event handler for File/Print preview menu item and print preview speed button }
begin
  PlusMemoPrinter1.MemoToPrint:= PlusMemo1;
  PlusMemoPrinter1.Preview;
  PlusMemoPrinter1.MemoToPrint:= nil
end;

procedure TFrmMain.SpeedBtnPrintClick(Sender: TObject);
    { Event handler for File/Print menu item and print speed button }
begin
  PlusMemoPrinter1.MemoToPrint:= PlusMemo1;
  PlusMemoPrinter1.Print
end;

procedure TFrmMain.LblBreakClick(Sender: TObject);
    { Event handler for LblBreak OnClick: changes the kind of line break in output files }
const BreakKindToString: array[TPlusLineBreak] of string = ('CRLF', 'LFCR', 'CR', 'LF');
begin
  with PlusMemo1 do
    begin
      if LineBreak<High(LineBreak) then LineBreak:= Succ(LineBreak)
                                   else LineBreak:= Low(LineBreak);
      LblBreak.Caption:= BreakKindToString[LineBreak]
    end
end;

procedure TFrmMain.rgBackgroundClick(Sender: TObject);
    { Event handler for Background radio group OnClick }
begin
  case rgBackground.ItemIndex of
    0: PlusMemo1.BackgroundBmp.Bitmap.Width:= 0;  { Empty }
    1: PlusMemo1.BackgroundBmp.Bitmap.Assign(fSavedECMBmp);
    2: begin
       if fCustomBmp.Empty then
         if CustomBmpFile='' then BtnCustomPicClick(rgBackground)
                             else fCustomBmp.LoadFromFile(CustomBmpFIle);
       PlusMemo1.BackgroundBmp.Bitmap.Assign(fCustomBmp)
       end
    end;

end;

procedure TFrmMain.BtnCustomPicClick(Sender: TObject);
    { Event handler for custom background speed button }
begin
  OpenPictureDialog1.FileName:= CustomBmpFile;
  if OpenPictureDialog1.Execute then
    begin
      CustomBmpFile:= OpenPictureDialog1.FileName;
      if Sender=rgBackground then PlusMemo1.BackgroundBmp.Bitmap.Assign(fCustomBmp)
                             else rgBackground.ItemIndex:= 2;
      fCustomBmp.LoadFromFile(CustomBmpFile)
    end
end;

end.

